/*Copyright (C) 2010-2011, Mozilla Corporation.

  All rights reserved.

  Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.*/
#if !defined(CELTDATA_H)
# define CELTDATA_H (1)
# include "celt.h"



extern const unsigned char CELT_LOG2_FRAC_TABLE[28];

/*Returns celt_log2_frac(_n,3) for _n in the range 1...33, inclusive.*/
#define CELT_LOG2_FRAC(_n) (CELT_LOG2_FRAC_TABLE[(_n)-1])

extern const opus_int16 CELT_EXP2_TABLE_Q14[8];

extern const opus_uint32        CELT_PVQ_U_DATA[1272];
extern const opus_uint32 *const CELT_PVQ_U_ROW[15];

/*U(N,K) = U(K,N) := N>0?K>0?U(N-1,K)+U(N,K-1)+U(N-1,K-1):0:K>0?1:0*/
# define CELT_PVQ_U(_n,_k) (CELT_PVQ_U_ROW[OPUS_MIN(_n,_k)][OPUS_MAX(_n,_k)])
/*V(N,K) := U(N,K)+U(N,K+1) = the number of PVQ codewords for a band of size N
   with K pulses allocated to it.*/
# define CELT_PVQ_V(_n,_k) (CELT_PVQ_U(_n,_k)+CELT_PVQ_U(_n,(_k)+1))


extern const unsigned char CELT_E_PROB_MODEL[4][2][42];

extern const float CELT_E_ALPHA[4];
extern const float CELT_E_BETA[4];
extern const float CELT_E_MEANS[25];


extern const signed char CELT_TF_SELECT[4][2][2][2];


extern const unsigned char CELT_SMALL_ENERGY_PDF[3];

#define CELT_TAPSET_PDF CELT_SMALL_ENERGY_PDF

extern const unsigned char CELT_SPREAD_PDF[4];

extern const unsigned char CELT_TRIM_PDF[11];

extern const unsigned char CELT_BIT_INTERLEAVE_TABLE[16];
extern const unsigned char CELT_BIT_DEINTERLEAVE_TABLE[16];
extern const unsigned char CELT_HADAMARD_ORDER_TABLE[30];

extern const float CELT_RSQRT_M[4];

extern const float CELT_TAPSETS[3][3];

#endif
