/*Copyright (C) 2010-2011, Mozilla Corporation.

  All rights reserved.

  Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.*/
#if !defined(SILKDATA_H)
# define SILKDATA_H (1)
# include "silk.h"



typedef struct silk_nlsf_codebook silk_nlsf_codebook;



struct silk_nlsf_codebook{
  unsigned char        stage1_pdfs[2*32];
  unsigned char        stage2_pdfs[8*9];
  const unsigned char *stage1_cb_q8;
  const unsigned char *stage2_indices;
  const unsigned char *stage2_pred_weights_q8;
  const opus_int16    *min_spacing_q15;
  const unsigned char *ordering;
  opus_int16           stage2_quant_step_q16;
  opus_int16           order;
};



extern const unsigned char SILK_LBRR_FLAG_PDFS[4+8];

extern const unsigned char SILK_STEREO_WEIGHTS_STAGE1_PDF[25];
extern const unsigned char SILK_STEREO_WEIGHTS_STAGE2_PDF[3];
extern const unsigned char SILK_STEREO_WEIGHTS_STAGE3_PDF[5];
extern const unsigned char SILK_MID_ONLY_PDF[2];

extern const unsigned char SILK_FRAME_TYPE_PDFS[2+6];

extern const unsigned char SILK_GAIN_HIGH_PDFS[3*8];
extern const unsigned char SILK_GAIN_LOW_PDF[8];
extern const unsigned char SILK_GAIN_DELTA_PDF[41];

extern const unsigned char SILK_NLSF_STAGE2_EXT_PDF[7];
extern const unsigned char SILK_NLSF_INTERP_WEIGHT_PDF[5];

extern const unsigned char SILK_PITCH_LAG_HIGH_PDF[32];
extern const unsigned char *const SILK_PITCH_LAG_LOW_PDFS[3];
extern const unsigned char SILK_PITCH_LAG_DELTA_PDF[21];
extern const unsigned char SILK_SUBFRAME_PITCH_PDFS[60];
extern const unsigned char SILK_SUBFRAME_PITCH_PDF_OFFS[4];
extern const unsigned char SILK_PERIODICITY_INDEX_PDF[3];
extern const unsigned char SILK_LTP_FILTER_PDFS[56];
extern const unsigned char SILK_LTP_FILTER_PDF_OFFS[3];
extern const unsigned char SILK_LTP_SCALE_PDF[3];

extern const unsigned char SILK_LCG_SEED_PDF[4];

extern const unsigned char SILK_RATE_LEVEL_PDFS[18];
extern const unsigned char SILK_PULSE_COUNT_PDFS[18*11-1];
extern const unsigned char SILK_SPLIT_PDFS[152*4];
extern const unsigned char SILK_LSB_PDF[2];
extern const unsigned char SILK_SIGN_PDFS[6*7*2];

extern const opus_int16 SILK_STEREO_WEIGHTS_Q13[15];
extern const opus_int16 SILK_STEREO_WEIGHT_DELTAS_Q13[15];

extern const silk_nlsf_codebook *const SILK_NLSF_CODEBOOKS[3];

extern const opus_int16 SILK_COS_Q12[129];

extern const signed char SILK_SUBFRAME_PITCH_CBS[210];
extern const unsigned char SILK_SUBFRAME_PITCH_CB_OFFS[4];
extern const signed char SILK_LTP_FILTER_CBS_Q7[56*5];
extern const opus_int16 SILK_LTP_SCALE_CB_Q14[3];

extern const opus_int16 SILK_QUANT_OFFSET_Q29[6];

#endif
