/*Copyright (C) 2010-2011, Mozilla Corporation.

  All rights reserved.

  Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.*/
#if !defined(SILKPRIV_H)
# define SILKPRIV_H (1)
# include <math.h>
# include "silk.h"
# include "opuspriv.h"
# include "silkdata.h"



typedef struct silk_channel_ctx     silk_channel_ctx;



struct silk_channel_ctx{
  opus_int16    previous_nlsf_q15[16];
  opus_int32    lpc_q29[16];
  float         unmix[2];
  opus_int16    out_q15[306];
  opus_int32    prev_gain_q16;
  unsigned char nlsf_interpolation_enabled;
  unsigned char previous_log_gain;
};




struct silk_decoder{
  unsigned char     stereo;
  unsigned char     prev_bw;
  unsigned char     prev_mid_only;
  opus_int16        prev_stereo_weight_q13[2];
  silk_channel_ctx  chan[1];
};



int silk_decode_impl(silk_decoder *_dec,opus_range_coder *_rc,
 float *_pcm,int _nchannels,int _bw,int _fsi);

#endif
